program Sort_reg2d
  use SEP
  implicit none
  integer                               :: nr,ns,nt,ii,jj,impt,ioff,nm,nh
  real                                  :: dt,dr,ds,ot,os,or,src,rec,mpt,off
  real                                  :: dm,om,dh,oh
  real, dimension(:,:,:),allocatable    :: data,model
  call sep_init()
  call from_history("n1",nt             ) 
  call from_history("n2",nr             )  
  call from_history("n3",ns             )  
  call from_history("d1",dt             ) 
  call from_history("d2",dr             )  
  call from_history("d3",ds             )  
  call from_history("o1",ot             ) 
  call from_history("o2",or             )  
  call from_history("o3",os             )
  dm=min(dr,ds)/2.
  om=(os+or)/2.
  nm=1+floor( ( (nr-1)*dr+or+(ns-1)*ds+os+(ns-1)*ds)/2/dm-om/dm  )
  dh=min(dr,ds)/2.
  oh=(or-os)/2.
  nh=1+floor( ( (nr-1)*dr+or+(ns-1)*ds+os-(ns-1)*ds)/2./dh-oh/dh)
  allocate( data(nt,nr,ns),model(nt,nh,nm) )
  call sep_read(data)
  do ii=1,ns
     do jj=1,nr
        src=(ii-1)*ds+os
        rec=((jj-1)*dr+or)+((ii-1)*ds+os)
        mpt=(rec+src)/2.
        off=(rec-src)/2.
        impt=1.5001 + (mpt-om)/dm  
        ioff=1.5001 + (off-oh)/dh  
        model(:,ioff,impt)=data(:,jj,ii)
     end do
  end do
    
  call to_history("n1",nt)
  call to_history("d1",dt)
  call to_history("o1",ot)
  call to_history("n3",nm)
  call to_history("d3",dm)
  call to_history("o3",om)
  call to_history("n2",nh)
  call to_history("d2",2*dh)
  call to_history("o2",oh)
  call hclose()
  call sep_write(model)
  call exit(0)
end program Sort_reg2d
